#ifndef LOGGER_HPP
#define LOGGER_HPP

#include <boost/log/sources/record_ostream.hpp>
#include <boost/log/sources/severity_logger.hpp>

#include <iostream>

#include <boost/shared_ptr.hpp>

//TODO Make it possible to change the log filename with a #define whitout the need to recompile
//TODO Make it possible to change the log filename while running
//TODO Make it possible to change the filter level for the console output 

class logger{
private:
	logger();
	logger(const logger&);
	logger& operator=(const logger&);
	
	class innerLogger;
	boost::shared_ptr<innerLogger> inner;
		
	static logger instance;
public:	

	typedef boost::log::sources::severity_logger_mt<level> loggerOstream;
	static loggerOstream& get();
	
	static void setThreadName(const std::string& name);
	
	~logger();
};

#endif //LOGGER_HPP
